﻿public class AddressFragment extends Fragment {
	private GUIPanelComponent rootPanel;
	private ISlot<Text> user;
	public AddressFragment(GUIPanelComponent rootPanel, ISlot<Text> user) {
		super(rootPanel);
		this.rootPanel = rootPanel;
		this.user = user;
		init();
	}
	private void init() {
		GUISlotListenerComponent gslc = GUISlotListenerComponent.create(rootPanel, User.PROPERTIES.shippingAddresses);
		GUIComponentBinding.create(user, gslc.element);
		GUIMultiplicityFilter gmfAddresses = GUIMultiplicityFilter.createIsNotEmpty(rootPanel, gslc.value);
		GUIDeckComponent deck = GUIDeckComponent.create(rootPanel);
		GUIPanelComponent address = GUIPanelComponent.createTable(deck);
		GUIComponentBinding.create(gmfAddresses.yes, address.show);
		GUIElementComponent.createInput(address, new GUIComboWidget(), GUISlotValueInput.create(User.PROPERTIES.shippingAddresses), 0, 0);
		GUIButtonComponent newLink = GUIButtonComponent.createLink(address, "${Add new}", 0, 1);
		GUIPanelComponent form = GUIPanelComponent.createTable(deck);
		GUIComponentBinding.create(gmfAddresses.no, form.show);
		GUIComponentBinding.create(newLink.click, form.show);
		GUIButtonComponent cancelLink = GUIButtonComponent.createLink(form, "${Cancel}", 0, 3);
		cancelLink.visible.set(Boolean.FALSE);
		GUIComponentBinding.create(gmfAddresses.booleanResult, cancelLink.visible);
		GUILabelComponent.create(form, "${First Name}", 0, 0).styleName.set(Text.fromString("label"));
		GUIElementComponent firstName = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, 1, 0);
		GUILabelComponent.create(form, "${Last Name}", 0, 2).styleName.set(Text.fromString("label"));
		GUIElementComponent lastName = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, 1, 2);
		GUILabelComponent.create(form, "${Phone}", 2, 0).styleName.set(Text.fromString("label"));
		GUIElementComponent phone = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, 3, 0);
		GUILabelComponent.create(form, "${Email}", 2, 2).styleName.set(Text.fromString("label"));
		GUIElementComponent email = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, 3, 2);
		GUILabelComponent.create(form, "${Address}", 4, 0).styleName.set(Text.fromString("label"));
		GUIElementComponent address1 = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, new TableLayoutData(5, 0, 0, 2));
		GUIElementComponent address2 = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, new TableLayoutData(6, 0, 0, 2));
		GUILabelComponent.create(form, "${City}", 7, 0).styleName.set(Text.fromString("label"));
		GUIElementComponent city = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, 8, 0);
		GUILabelComponent.create(form, "${Postal Code}", 9, 0).styleName.set(Text.fromString("label"));
		GUIElementComponent postalCode = GUIElementComponent.createInput(form, GUIFieldWidget.create(Text.CLASSIFIER), null, 10, 0);
		GUILabelComponent.create(form, "${State / Region}", 7, 2).styleName.set(Text.fromString("label"));
		GUIPanelComponent wrap = GUIPanelComponent.createFlow(form);
		TableLayoutData.setRowColumn(wrap, 8, 2);
		GUIElementComponent stateRegion = GUIElementComponent.createInput(wrap, GUIFieldWidget.create(Text.CLASSIFIER), null);
		GUIElementComponent stateRegionDropDown = GUIElementComponent.createInput(form, new GUIComboWidget(), GUISlotValueInput.create(Country.PROPERTIES.regions));
		stateRegionDropDown.visible.set(Boolean.FALSE);
		GUILabelComponent.create(form, "${Country}", 9, 2).styleName.set(Text.fromString("label"));
		GUIElementComponent country = GUIElementComponent.createInput(form, new GUIComboWidget(), GUISubnodesInput.create(Address.CLASSIFIER, false), 10, 2);
		GUIComponentBinding.create(country.value, GUISlotValueInput.get(stateRegionDropDown).element);
		GUIMultiplicityFilter gmf = GUIMultiplicityFilter.createIsNotEmpty(wrap, country.value);
		GUIComponentBinding.create(gmf.booleanResult, stateRegionDropDown.visible);
		GUINotGate gng = GUINotGate.create(wrap);
		GUIComponentBinding.create(gmf.booleanResult, gng.input);
		GUIComponentBinding.create(gng.output, stateRegion.visible);
		GUICommandComponent comm1 = GUICommandComponent.create(rootPanel, new SetCountryRegion(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(country.value, comm1, SetCountryRegion.PROPERTIES.country);
		GUIComponentBinding.create(stateRegion.value, comm1, SetCountryRegion.PROPERTIES.region);
		GUIComponentBinding.create(comm1, SetCountryRegion.PROPERTIES.selected, stateRegionDropDown.value);
	}
}