﻿public class CheckoutFragment extends Fragment {
	private GUIPanelComponent rootPanel;
	private ISlot<Text> user;
	private ISlot<Text> order;
	public CheckoutFragment(GUIPanelComponent rootPanel, ISlot<Text> user, ISlot<Text> order) {
		super(rootPanel);
		this.rootPanel = rootPanel;
		this.user = user;
		this.order = order;
		init();
	}
	private void init() {
		GUIPanelComponent leftCol = GUIPanelComponent.createFlow(rootPanel);
		leftCol.styleName.set(Text.fromString("threeColumnLeftContent"));
		NavigationFragment navig = new NavigationFragment(rootPanel);
		GUIComponentBinding.create(user, navig.user);
		GUIPanelComponent rightCol = GUIPanelComponent.createFlow(rootPanel);
		rightCol.styleName.set(Text.fromString("threeColumnRightContent"));
		GUIDisclosurePanel baDiscl = GUIDisclosurePanel.create(rightCol, "${Billing Address}");
		AddressDisplayFragment adf = new AddressDisplayFragment(baDiscl, false);
		GUIComponentBinding.create(order, adf.order);
		GUIDisclosurePanel saDiscl = GUIDisclosurePanel.create(rightCol, "${Shipping Address}");
		AddressDisplayFragment adf2 = new AddressDisplayFragment(saDiscl, true);
		GUIComponentBinding.create(order, adf2.order);
		GUIDisclosurePanel payMethDisc = GUIDisclosurePanel.create(rightCol, "${Payment Method}");
		GUIElementComponent paymeth = GUIElementComponent.createSlotEditor(payMethDisc, Order.PROPERTY.paymentMethod);
		GUISlotEditorKind.get(paymeth).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(paymeth).displayAsLabel.set(Boolean.TRUE);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(paymeth).element);
		GUIDisclosurePanel shipMethDisc = GUIDisclosurePanel.create(rightCol, "${Shipping Method}");
		GUIElementComponent shipmeth = GUIElementComponent.createSlotEditor(shipMethDisc, Order.PROPERTY.shipmentMethod);
		GUISlotEditorKind.get(shipmeth).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(shipmeth).displayAsLabel.set(Boolean.TRUE);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(shipmeth).element);
		GUIDisclosurePanel couponDisc = GUIDisclosurePanel.create(rightCol, "${Coupon Information}");
		GUIElementComponent coupon = GUIElementComponent.createSlotEditor(shipMethDisc, Order.PROPERTY.coupon);
		GUISlotEditorKind.get(coupon).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(coupon).displayAsLabel.set(Boolean.TRUE);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(coupon).element);
		GUIDisclosurePanel payInfDisc = GUIDisclosurePanel.create(rightCol, "${Payment Information}");
		GUIElementComponent ccType = GUIElementComponent.createSlotEditor(shipMethDisc, Order.PROPERTY.creditCardType);
		GUISlotEditorKind.get(ccType).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(ccType).displayAsLabel.set(Boolean.TRUE);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(ccType).element);
		GUILabelComponent.create(payInfDisc, "*******").styleName.set(Text.fromString("maskedCCN"));
		GUIElementComponent ccExpDate = GUIElementComponent.createSlotEditor(shipMethDisc, Order.PROPERTY.creditCardExpDate);
		GUISlotEditorKind.get(ccExpDate).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(ccExpDate).displayAsLabel.set(Boolean.TRUE);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(ccExpDate).element);
		GUIPanelComponent mainCol = GUIPanelComponent.createFlow(rootPanel);
		mainCol.styleName.set(Text.fromString("threeColumnMainContent"));
		GUIDisclosurePanel biDisc = GUIDisclosurePanel.create(mainCol, "${Billing Information}");
		AddressFragment af = new AddressFragment(biDisc, user);
		GUIElementComponent useShip = GUIElementComponent.createInputCheckbox(biDisc, null, "${Use for shipping?}", false);
		GUIButtonComponent billCmd = GUIButtonComponent.create(biDisc, "${Continue}", new BillingInfoCmd());
		GUIComponentBinding.create(order, billCmd, BillingInfoCmd.PROPERTIES.order);
		GUIComponentBinding.create(billCmd.commandExecuted, baDiscl.open);
		GUIDisclosurePanel siDisc = GUIDisclosurePanel.create(mainCol, "${Shipping Information}");
		AddressFragment af2 = new AddressFragment(siDisc, user);
		GUIButtonComponent shipCmd = GUIButtonComponent.create(siDisc, "${Continue}", new ShippingInfoCmd());
		GUIComponentBinding.create(order, shipCmd, ShippingInfoCmd.PROPERTIES.order);
		GUIComponentBinding.create(shipCmd.commandExecuted, saDiscl.open);
		GUIComponentBinding.create(billCmd.commandExecuted, biDisc.open);
		GUIDisclosurePanel soDisc = GUIDisclosurePanel.create(mainCol, "${Shipping Options}");
		GUIElementComponent rbl = GUIElementComponent.createSlotEditorRadio(soDisc, Order.PROPERTIES.shippingOptions);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(rbl).element);
		GUIButtonComponent shipOptCmd = GUIButtonComponent.create(siDisc, "${Continue}", new ShippingOptionsCmd());
		GUIComponentBinding.create(order, shipOptCmd, ShippingOptionsCmd.PROPERTIES.order);
		GUIComponentBinding.create(shipOptCmd.commandExecuted, saDiscl.open);
		GUIDisclosurePanel ciDisc = GUIDisclosurePanel.create(mainCol, "${Coupon Information}");
		GUILabelComponent.create(ciDisc, "${Coupon Code}");
		GUIElementComponent couponCode = GUIElementComponent.createInput(ciDisc, null, Text.CLASSIFIER);
		GUIButtonComponent couponCmd = GUIButtonComponent.create(ciDisc, "${Continue}", new CouponInfoCmd());
		GUIComponentBinding.create(shipOptCmd.commandExecuted, ciDisc.open);
		GUIComponentBinding.create(shipCmd.commandExecuted, couponDisc.open);
		GUIComponentBinding.create(couponCode.value, couponCmd, CouponInfoCmd.PROPERTIES.code);
		GUIComponentBinding.create(order, couponCmd, CouponInfoCmd.PROPERTIES.order);
		GUIDisclosurePanel payDisc = GUIDisclosurePanel.create(mainCol, "${Payment Information}");
		GUIElementComponent payopt = GUIElementComponent.createSlotEditor(payDisc, Order.PROPERTIES.payingOptions);
		GUIComponentBinding.create(order, GUISlotEditorKind.get(payopt).element);
		GUILabelComponent.create(payDisc, "${Credit card number}");
		GUIElementComponent cNum = GUIElementComponent.createInput(ciDisc, null, Text.CLASSIFIER);
		GUILabelComponent.create(payDisc, "${Security number}");
		GUIElementComponent secNum = GUIElementComponent.createInput(ciDisc, null, Text.CLASSIFIER);
		GUILabelComponent.create(payDisc, "${Issue number}");
		GUIElementComponent issNum = GUIElementComponent.createInput(ciDisc, null, Text.CLASSIFIER);
		GUILabelComponent.create(payDisc, "${Expiration mo/yr}");
		GUIElementComponent month = GUIElementComponent.createInput(ciDisc, null, Text.CLASSIFIER);
		GUIElementComponent year = GUIElementComponent.createInput(ciDisc, null, Text.CLASSIFIER);
		GUIButtonComponent payOptCmd = GUIButtonComponent.create(siDisc, "${Continue}", new PayingOptionsCmd());
		GUIComponentBinding.create(order, payOptCmd, PayingOptionsCmd.PROPERTIES.order);
		GUIComponentBinding.create(cNum.value, payOptCmd, PayingOptionsCmd.PROPERTIES.creditCardNumber);
		GUIComponentBinding.create(secNum.value, payOptCmd, PayingOptionsCmd.PROPERTIES.securityNumber);
		GUIComponentBinding.create(issNum.value, payOptCmd, PayingOptionsCmd.PROPERTIES.issueNumber);
		GUIComponentBinding.create(month.value, payOptCmd, PayingOptionsCmd.PROPERTIES.expMonth);
		GUIComponentBinding.create(year.value, payOptCmd, PayingOptionsCmd.PROPERTIES.expYear);
		GUIComponentBinding.create(payOptCmd.commandExecuted, payInfDisc.open);
		GUIDisclosurePanel summaryDisc = GUIDisclosurePanel.create(mainCol, "${Order Summary}");
		OrderSummary os = new OrderSummary(summaryDisc, order);
		GUIButtonComponent processOrderCmd = GUIButtonComponent.create(summaryDisc, "${Continue}", new ProcessOrderCmd());
		GUIComponentBinding.create(order, processOrderCmd, ProcessOrderCmd.PROPERTIES.order);
		GUIComponentBinding.create(processOrderCmd.commandExecuted, baDiscl.open);
		GUIComponentBinding.create(payOptCmd.commandExecuted, summaryDisc.open);
	}
}