﻿public class ProductFragment extends Fragment {
	private GUIPanelComponent rootPanel;
	private ISlot<Text> user;
	private ISlot<Text> product;
	private boolean isAdmin;
	public ProductFragment(GUIPanelComponent rootPanel, ISlot<Text> user, ISlot<Text> product, boolean isAdmin) {
		super(rootPanel);
		this.rootPanel = rootPanel;
		this.user = user;
		this.product = product;
		this.isAdmin = isAdmin;
		init();
	}
	private void init() {
		GUIPanelComponent leftCol = GUIPanelComponent.createFlow(rootPanel);
		leftCol.styleName.set(Text.fromString("threeColumnLeftContent"));
		NavigationFragment navig = new NavigationFragment(rootPanel);
		GUIComponentBinding.create(user, navig.user);
		GUIPanelComponent rightCol = GUIPanelComponent.createFlow(rootPanel);
		rightCol.styleName.set(Text.fromString("threeColumnRightContent"));
		GUIElementComponent quantity = GUIElementComponent.createInput(rightCol, null, Integer.CLASSIFIER);
		GUIElementComponent comboQuantity = GUIElementComponent.createInput(rightCol, new GUIComboWidget(), GUICollectionInput.create(listValues));
		GUIButtonComponent.create(rightCol, "${Add to cart}", new AddToCartComponent());
		ProductReviewFragment prf = new ProductReviewFragment(rightCol);
		GUIComponentBinding.create(product, prf.product);
		GUIPanelComponent mainCol = GUIPanelComponent.createFlow(rootPanel);
		mainCol.styleName.set(Text.fromString("threeColumnMainContent"));
		GUIElementComponent prod = GUIElementComponent.createSlotEditor(mainCol, Product.PROPERTIES.name);
		GUISlotEditorKind.get(prod).readOnly.set(Boolean.FALSE);
		GUISlotEditorKind.get(prod).displayAsLabel.set(Boolean.FALSE);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(prod).element);
		if (isAdmin) {
			GUILinkComponent linkedit = GUILinkComponent.create(mainCol);
			EditProductFragment edf = new EditProductFragment(rootPanel, product);
			GUIComponentBinding.create(linkedit.click, edf.show);
		}
		GUIElementComponent retailPrice = GUIElementComponent.createSlotEditor(mainCol, Product.PROPERTIES.retailPrice);
		GUISlotEditorKind.get(retailPrice).readOnly.set(Boolean.FALSE);
		GUISlotEditorKind.get(retailPrice).displayAsLabel.set(Boolean.FALSE);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(retailPrice).element);
		GUIElementComponent ourPrice = GUIElementComponent.createSlotEditor(mainCol, Product.PROPERTIES.ourPrice);
		GUISlotEditorKind.get(ourPrice).readOnly.set(Boolean.FALSE);
		GUISlotEditorKind.get(ourPrice).displayAsLabel.set(Boolean.FALSE);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(ourPrice).element);
		GUIElementComponent savings = GUIElementComponent.createSlotEditor(mainCol, Product.PROPERTIES.savings);
		GUISlotEditorKind.get(savings).readOnly.set(Boolean.FALSE);
		GUISlotEditorKind.get(savings).displayAsLabel.set(Boolean.FALSE);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(savings).element);
		RatingFragment rf = new RatingFragment(mainCol, product);
		GUIElementComponent descr = GUIElementComponent.createSlotEditor(mainCol, Product.PROPERTIES.description);
		GUISlotEditorKind.get(descr).readOnly.set(Boolean.FALSE);
		GUISlotEditorKind.get(descr).displayAsLabel.set(Boolean.FALSE);
		GUILabelComponent.create(mainCol, "${Sizes}");
		GUIElementComponent comboSizes = GUIElementComponent.createInput(rightCol, new GUIComboWidget(), new GUISlotValueInput());
		GUIComponentBinding.create(product, GUISlotValueInput.get(combSizes).element);
	}
}