public class ProducStockFragment extends Fragment {
	private ISlot<Text> product;
	public ProducStockFragment(GUIPanelComponent rootPanel, ISlot<Text> product) {
		super(rootPanel);
		this.product = product;
		init();
	}
	private void init() {
		GUIPanelComponent base = GUIPanelComponent.createFlow(rootPanel);
		GUIConformsToFilter isVar = GUIConformsToFilter.create(base, product, Variant.CLASSIFIER);
		GUILabelComponent.create(base, "${Stock}").styleName.set(Text.fromString("heading"));
		GUIElementComponent seHasDimmensions = GUIElementComponent.createSlotEditorCheckbox(general, Variant.PROPERTIES.hasDimensions, isVar.yes, "", null);
		GUIComponentBinding.create(isVar.booleanResult, seHasDimmensions.visible);
		GUIPanelComponent dimensions = GUIPanelComponent.createFieldset(base, "${Dimension}");
		GUIPanelComponent table = GUIPanelComponent.createTable(dimensions);
		int row = 0;
		GUILabelComponent.create(dimensions, "${Weight:}", row++, 0);
		GUIElementComponent.createSlotEditor(dimensions, Product.PROPERTIES.weight, product, row, 0);
		GUILabelComponent.create(dimensions, "${kg}", row++, 1);
		GUILabelComponent.create(dimensions, "${Height:}", row++, 0);
		GUIElementComponent.createSlotEditor(dimensions, Product.PROPERTIES.height, product, row, 0);
		GUILabelComponent.create(dimensions, "${m}", row++, 1);
		GUILabelComponent.create(dimensions, "${Width:}", row++, 0);
		GUIElementComponent.createSlotEditor(dimensions, Product.PROPERTIES.width, product, row, 0);
		GUILabelComponent.create(dimensions, "${m}", row++, 1);
		GUILabelComponent.create(dimensions, "${Length:}", row++, 0);
		GUIElementComponent.createSlotEditor(dimensions, Product.PROPERTIES.lenth, product, row, 0);
		GUILabelComponent.create(dimensions, "${m}", row++, 1);
		GUIPanelComponent stockdata = GUIPanelComponent.createFieldset(base, "${Stock Data}");
		GUILabelComponent.create(stockdata, "${Deliverable:}");
		GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.deliverable, product);
		GUILabelComponent.create(stockdata, "${Manual delivery time:}");
		GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.isManualDelivery, product);
		GUIFindAllInstancesSAPComponent delTimes = GUIFindAllInstancesSAPComponent.create(stockdata, DeliveryTimes.FQ_TYPE_NAME);
		GUIElementComponent seDT = GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.deliveryTime, new GUIComboWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(seDT).element);
		GUIComponentBinding.create(delTimes.value, GUICollectionInput.get(seDT).collection);
		GUIComponentBinding.create(product, delTimes.refresh);
		GUILabelComponent.create(stockdata, "${Manage stock ammount:}");
		GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.isStockManage, product);
		GUILabelComponent.create(stockdata, "${Stock ammount:}");
		GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.stockAmmount, product);
		GUILabelComponent.create(stockdata, "${Order time:}");
		GUIElementComponent seOT = GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.orderTime, new GUIComboWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(seOT).element);
		GUIComponentBinding.create(delTimes.value, GUICollectionInput.get(seOT).collection);
		GUILabelComponent.create(stockdata, "${Ordered at:}");
		GUIElementComponent.createSlotEditor(stockdata, Product.PROPERTIES.orderedAt, product);
		GUIPanelComponent packaging = GUIPanelComponent.createFieldset(base, "${Packaging Unit}");
		GUILabelComponent.create(packaging, "${Active Packaging Unit:}");
		GUIElementComponent.createSlotEditor(packaging, Product.PROPERTIES.activePackUnit, product);
		GUILabelComponent.create(packaging, "${Packagaing unit:}");
		GUIElementComponent.createSlotEditor(packaging, Product.PROPERTIES.packUnit, product);
		GUILabelComponent.create(packaging, "${Unit:}");
		GUIElementComponent.createSlotEditor(packaging, Product.PROPERTIES.unit, product);
	}
}