public class ProductGeneralDataFragment extends Fragment {
	private ISlot<Text> product;
	public ProductGeneralDataFragment(GUIPanelComponent rootPanel, ISlot<Text> product) {
		super(rootPanel);
		this.product = product;
		init();
	}
	private void init() {
		GUIPanelComponent base = GUIPanelComponent.createFlow(rootPanel);
		GUIConformsToFilter isVar = GUIConformsToFilter.create(base, product, Variant.CLASSIFIER);
		GUITransformerComponent myParent = GUITransformerComponent.transformToSlotValue(base, Variant.PROPERTIES.parent);
		GUIComponentBinding.create(isVar.yes, myParent.input);
		GUITransformerComponent isConf = GUITransformerComponent.transformToSlotValue(base, Product.PROPERTIES.isConfigurable);
		GUIComponentBinding.create(product, isConf.input);
		GUIBooleanFilter isConfig = GUIBooleanFilter.create(base, isConf.output);
		GUILabelComponent.create(base, "${Data}").styleName.set(Text.fromString("heading"));
		GUIPanelComponent general = GUIPanelComponent.createFieldset(base, "${General}");
		GUILabelComponent.create(general, "${Active:}");
		GUIElementComponent.createSlotEditor(general, Product.PROPERTIES.isActive, product);
		GUIElementComponent seHasVarName = GUIElementComponent.createSlotEditorCheckbox(general, Variant.PROPERTIES.hasName, isVar.yes, "", null);
		GUIComponentBinding.create(isVar.booleanResult, seHasVarName.visible);
		GUILabelComponent.create(general, "${Name:}");
		GUIElementComponent.createSlotEditor(general, Product.PROPERTIES.name, product);
		GUIElementComponent seParentName = GUIElementComponent.createSlotEditor(general, Product.PROPERTIES.name, myParent.output);
		setReadonly(seParentName);
		GUIComponentBinding.create(isVar.booleanResult, seParentName.visible);
		GUIPanelComponent urls = GUIPanelComponent.createFieldset(base, "${URLs}");
		GUILabelComponent.create(urls, "${Slug:}");
		GUIElementComponent.createSlotEditor(urls, Product.PROPERTIES.slug, product);
		GUIElementComponent parentSlug = GUIElementComponent.createSlotEditor(urls, Product.PROPERTIES.slug, myParent.output);
		GUIComponentBinding.create(isVar.booleanResult, parentSlug.visible);
		GUILabelComponent.create(urls, "${Redirect to:}");
		GUIElementComponent.createSlotEditor(urls, Product.PROPERTIES.redirectTo, product);
		GUIPanelComponent articleNums = GUIPanelComponent.createFieldset(base, "${Article numbers}");
		GUIElementComponent seHasVarSKU = GUIElementComponent.createSlotEditorCheckbox(articleNums, Variant.PROPERTIES.hasSKU, isVar.yes, "", null);
		GUIComponentBinding.create(isVar.booleanResult, seHasVarSKU.visible);
		GUILabelComponent.create(articleNums, "${SKU:}");
		GUIElementComponent.createSlotEditor(articleNums, Product.PROPERTIES.sku, product);
		GUILabelComponent.create(articleNums, "${SKU manufacturer:}");
		GUIElementComponent.createSlotEditor(articleNums, Product.PROPERTIES.skuManufact, product);
		GUIPanelComponent prices = GUIPanelComponent.createFieldset(base, "${Prices}");
		GUIElementComponent hasVarPrice = GUIElementComponent.createSlotEditor(prices, Variant.PROPERTIES.hasPrice, isVar.yes);
		GUIComponentBinding.create(isVar.booleanResult, hasVarPrice.visible);
		GUILabelComponent.create(prices, "${Price:}");
		GUIElementComponent.createSlotEditor(prices, Product.PROPERTIES.price, product);
		GUIElementComponent seParentPrice = GUIElementComponent.createSlotEditor(prices, Product.PROPERTIES.price, myParent.output);
		setReadonly(seParentPrice);
		GUIComponentBinding.create(isVar.booleanResult, seParentPrice.visible);
		GUILabelComponent taxlabel = GUILabelComponent.create(prices, "${Tax:}");
		GUIFindAllInstancesSAPComponent taxes = GUIFindAllInstancesSAPComponent.create(prices, Tax.FQ_TYPE_NAME);
		GUIElementComponent seTax = GUIElementComponent.createSlotEditor(prices, Product.PROPERTIES.price, new GUIComboWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(seTax).element);
		GUIComponentBinding.create(taxes.value, GUICollectionInput.get(seTax).collection);
		GUIComponentBinding.create(product, taxes.refresh);
		GUINotGate gng = GUINotGate.create(prices);
		GUIComponentBinding.create(isVar.booleanResult, gng.input);
		GUIComponentBinding.create(gng.output, taxlabel.visible);
		GUIComponentBinding.create(gng.output, seTax.visible);
		GUIElementComponent seIsCustomCalc = GUIElementComponent.createSlotEditorCheckbox(prices, Product.PROPERTIES.isCustomCalc, product, "${Price Calculation:}", null);
		GUIElementComponent seCustomPriceCalc = GUIElementComponent.createSlotEditor(prices, Product.PROPERTIES.customPriceCalc, product);
		GUIComponentBinding.create(isConfig.booleanResult, seIsCustomCalc.visible);
		GUIComponentBinding.create(isConfig.booleanResult, seCustomPriceCalc.visible);
		GUILabelComponent.create(prices, "${Price calculator:}");
		GUIFindAllInstancesSAPComponent priceCalcs = GUIFindAllInstancesSAPComponent.create(prices, PriceCalculator.FQ_TYPE_NAME);
		GUIElementComponent sePriceCalc = GUIElementComponent.createSlotEditor(prices, Product.PROPERTIES.priceCalc, new GUIComboWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(sePriceCalc).element);
		GUIComponentBinding.create(priceCalcs.value, GUICollectionInput.get(sePriceCalc).collection);
		GUIComponentBinding.create(product, priceCalcs.refresh);
		GUIPanelComponent simpleSale = GUIPanelComponent.createFlow(prices);
		GUIElementComponent.createSlotEditorCheckbox(simpleSale, Product.PROPERTIES.isForSale, product, "${For sale:}", null);
		GUIElementComponent.createSlotEditor(simpleSale, Product.PROPERTIES.salesPrice, product);
		GUIComponentBinding.create(gng.output, simpleSale.visible);
		GUIPanelComponent complexSale = GUIPanelComponent.createFlow(prices);
		GUIComponentBinding.create(isVar.booleanResult, complexSale.visible);
		GUILabelComponent.create(complexSale, "${For sale:}");
		GUIElementComponent.createSlotEditor(complexSale, Variant.PROPERTIES.salesType, isVar.yes);
		GUIElementComponent seIsParentSales = GUIElementComponent.createSlotEditor(complexSale, Variant.PROPERTIES.isForSale, myParent.output);
		setReadonly(seIsParentSales);
		GUIElementComponent.createSlotEditorCheckbox(complexSale, Variant.PROPERTIES.hasSalesPrice, isVar.yes, "${For sale price:}", null);
		GUIElementComponent.createSlotEditor(complexSale, Product.PROPERTIES.salesPrice, isVar.yes);
		GUIElementComponent parentSalesPrice = GUIElementComponent.createSlotEditor(complexSale, Product.PROPERTIES.salesPrice, isVar.yes);
		setReadonly(parentSalesPrice);
		GUIPanelComponent units = GUIPanelComponent.createFieldset(base, "${Units}");
		GUIComponentBinding.create(gng.output, units.visible);
		GUILabelComponent.create(units, "${Unit:}");
		GUIElementComponent.createSlotEditor(units, Product.PROPERTIES.unit, product);
		GUILabelComponent.create(units, "${Price unit:}");
		GUIElementComponent.createSlotEditor(units, Product.PROPERTIES.priceUnit, product);
		GUIElementComponent hasVarDesc = GUIElementComponent.createSlotEditorCheckbox(base, Variant.PROPERTIES.hasShortDesc, isVar.yes, "", null);
		GUIComponentBinding.create(isVar.booleanResult, hasVarDesc.visible);
		GUILabelComponent.create(base, "${Short description:}");
		GUIElementComponent shortDesc = GUIElementComponent.createSlotEditor(base, Product.PROPERTIES.shortDesc, product);
		GUIFieldWidget.get(shortDesc).isHTML.set(Boolean.TRUE);
		GUIElementComponent hasVarDescription = GUIElementComponent.createSlotEditorCheckbox(base, Variant.PROPERTIES.hasDescription, isVar.yes, "", null);
		GUIComponentBinding.create(isVar.booleanResult, hasVarDescription.visible);
		GUILabelComponent.create(base, "${Description:}");
		GUIElementComponent longDesc = GUIElementComponent.createSlotEditor(base, Product.PROPERTIES.description, product);
		GUIFieldWidget.get(longDesc).isHTML.set(Boolean.TRUE);
		GUIPanelComponent appearance = GUIPanelComponent.createFieldset(base, "${Appearance}");
		GUIElementComponent hasStaticBlock = GUIElementComponent.createSlotEditorCheckbox(base, Variant.PROPERTIES.hasStaticBlock, isVar.yes, "", null);
		GUIComponentBinding.create(isVar.booleanResult, hasStaticBlock.visible);
		GUILabelComponent.create(appearance, "${Static block:}");
		GUIFindAllInstancesSAPComponent staticBlocks = GUIFindAllInstancesSAPComponent.create(appearance, StaticHTML.FQ_TYPE_NAME);
		GUIElementComponent seHTML = GUIElementComponent.createSlotEditor(appearance, Product.PROPERTIES.html, new GUIComboWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(seHTML).element);
		GUIComponentBinding.create(staticBlocks.value, GUICollectionInput.get(seHTML).collection);
		GUIComponentBinding.create(product, staticBlocks.refresh);
		GUILabelComponent.create(appearance, "${Product template:}");
		GUIFindAllInstancesSAPComponent templates = GUIFindAllInstancesSAPComponent.create(appearance, Template.FQ_TYPE_NAME);
		GUIElementComponent seTemplate = GUIElementComponent.createSlotEditor(appearance, Product.PROPERTIES.template, new GUIComboWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(product, GUISlotEditorKind.get(seTemplate).element);
		GUIComponentBinding.create(templates.value, GUICollectionInput.get(seTemplate).collection);
		GUIComponentBinding.create(product, templates.refresh);	
	}
	private void setReadonly(GUIElementComponent gec) {
		GUISlotEditorKind.get(gec).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(gec).displayAsLabel.set(Boolean.TRUE);
	}
}