﻿public class RelatedProductsFragment extends Fragment {
	private ISlot<Text> product;
	@Parameter @Result("${Product}")
	public static final String NAME = "NAME";
	@Result("${House}") @OrderByAnother(NAME)
	public static final String PRODUCT = "PRODUCT";
	@Parameter @Result("${SKU}")
	public static final String SKU = "SKU";
	@Parameter @Result("${Active}")
	public static final String ACTIVE = "ACTIVE";
	@Parameter
	public static final String CATEGORY = "ACTIVE";
    public RelatedProductsFragment(GUIPanelComponent rootPanel, ISlot<Text> product) {
		super(rootPanel);
		this.product = product;
		init();
	}
	private void init() {
		GUIPanelComponent base = GUIPanelComponent.createFlow(rootPanel);
		GUILabelComponent.create(base, "${Related Products}").styleName.set(Text.fromString("heading"));
		GUISearchPanelComponent searchForm = GUISearchPanelComponent.create(rootPanel, new FlowLayout());
		searchForm.styleName.set(Text.fromString("form"));
		GUILabelComponent.create(searchForm, "${Selectable Products}").styleName.set(Text.fromString("heading"));
		GUIPanelComponent table = GUIPanelComponent.createTable(searchForm);
		table.styleName.set(Text.fromString("table"));
		LayoutData.setSize(table, "50%", null);
		GUIElementComponent nameParam = GUIElementComponent.createInput(table, NAME, Text.CLASSIFIER, 0, 1);
		GUIElementComponent category = GUIElementComponent.createInput(table, CATEGORY, new GUISuggestWidget(), new GUICollectionInput(), new TableLayoutData(0, 3));
		GUIFindAllInstancesSAPComponent allCategories = GUIFindAllInstancesSAPComponent.create(rootPanel, Category.FQ_TYPE_NAME);
		GUIComponentBinding.create(allCategories.value, GUICollectionInput.get(category).collection);
		GUIPanelComponent buttonPanel = GUIPanelComponent.createFlow(rootPanel);
		GUIButtonComponent searchButton = GUIButtonComponent.create(buttonPanel, "${Search}");
		searchButton.styleName.set(Text.fromString("submitButton"));
		GUIButtonComponent resetButton = GUIButtonComponent.create(buttonPanel, "${Reset}");
		resetButton.styleName.set(Text.fromString("submitButton"));
		GUIButtonComponent selectAll = GUIButtonComponent.create(buttonPanel, "${Reset}");
		selectAll.styleName.set(Text.fromString("submitButton"));
		GUIButtonComponent unselectAll = GUIButtonComponent.create(buttonPanel, "${Reset}");
		unselectAll.styleName.set(Text.fromString("submitButton"));
		ProductSearch searchResult = new ProductSearch();
		searchResult.parent.set(rootPanel);
		searchResult.doInitialSearch.set(Boolean.FALSE);
		searchForm.dynamicBindingDest.set(searchResult);
		GUIComponentBinding.create(selectAll.click, searchResult.selectAll);
		GUIComponentBinding.create(unselectAll.click, searchResult.unselectAll);
		LayoutData.setSize(searchResult, "50%", null);
		GUIComponentBinding.create(searchButton.click, searchResult.search);
		GUIComponentBinding.create(resetButton.click, searchForm.reset);
		GUIComponentBinding.create(resetButton.click, searchResult.clearContents);
		GUIButtonComponent add = GUIButtonComponent.create(buttonPanel, "${Add to related products}", new AddRelatedProduct());
		GUIComponentBinding.create(searchResult.selection, add, AddRelatedProduct.PROPERTIES.products);
		GUIComponentBinding.create(product, add, AddRelatedProduct.PROPERTIES.target);
		GUISearchPanelComponent selectedTable = GUISearchPanelComponent.create(rootPanel, new FlowLayout());
		selectedTable.styleName.set(Text.fromString("floatRight"));
		GUILabelComponent.create(selectedTable, "${Selected Products}").styleName.set(Text.fromString("heading"));
		GUIElementComponent nameComponent = GUIElementComponent.createSlotEditor(null, Product.PROPERTIES.name);
		GUIElementComponent skuComponent = GUIElementComponent.createSlotEditor(null, Product.PROPERTIES.sku);
		GUIElementComponent activeComponent = GUIElementComponent.createSlotEditor(null, Product.PROPERTIES.isActive);
		GUITableWidget gtw1 = GUITableWidget.create(new String[] { "${Room}", "${Name}", "${Size}" },
				new GUIComponent[] { nameComponent, skuComponent, activeComponent });
		gtw1.minRows.set(Integer.valueOf(5));
		GUIPanelComponent tableWrap = GUIPanelComponent.createFlow(rootPanel);
		tableWrap.styleName.set(Text.fromString("productTable"));
		GUIElementComponent productsTable = GUIElementComponent.create(tableWrap, new GUIInputKind(), gtw1, GUISlotValueInput.create(Product.PROPERTIES.relatedProducts));
		GUIComponentBinding.create(product, GUISlotValueInput.get(productsTable).element);
		GUIPanelComponent buttonPanel2 = GUIPanelComponent.createFlow(selectedTable);
		GUIButtonComponent selectAll2 = GUIButtonComponent.create(buttonPanel2, "${Reset}");
		selectAll.styleName.set(Text.fromString("submitButton"));
		GUIButtonComponent unselectAll2 = GUIButtonComponent.create(buttonPanel2, "${Reset}");
		unselectAll.styleName.set(Text.fromString("submitButton"));
		GUIComponentBinding.create(selectAll2.click, searchResult.selectAll);
		GUIComponentBinding.create(unselectAll2.click, searchResult.unselectAll);
		GUIButtonComponent remove = GUIButtonComponent.create(buttonPanel2, "${Remove from related products}", new RemoveRelatedProduct());
		GUIComponentBinding.create(searchResult.selection, remove, RemoveRelatedProduct.PROPERTIES.products);
		GUIComponentBinding.create(product, remove, RemoveRelatedProduct.PROPERTIES.target);
		GUIComponentBinding.create(nameParam.keyUp, searchResult.search);
	}
}