﻿public class DocumentExtPropertiesFragment extends Fragment {
	private ISlot<Text> document;
	private GUIPanelComponent versionPanel;
	public DocumentExtPropertiesFragment(GUIPanelComponent rootPanel, ISlot<Text> document, GUIPanelComponent versionPanel) {
		super(rootPanel);
		this.document = document;
		this.versionPanel = versionPanel;	
		init();
	}
	private void init() {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		GUIFindAllInstancesSAPComponent templateSAP = GUIFindAllInstancesSAPComponent.create(table, Template.FQ_TYPE_NAME);
		int row = 0, column = 0;
		GUILabelComponent.create(table, "${Source}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Recipient}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Type}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Date}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Author}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		row = 0; column++;
		GUILabelComponent.create(table, "${Original ID}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Object}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Coverage}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Template}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		row = 1; column = 0;
		GUIElementComponent seSource = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.source, document, row++, column); row++;
		GUIElementComponent seRecipient = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.recipient, document, row++, column); row++;
		GUIElementComponent seType = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.type, document, row++, column); row++;
		GUIElementComponent seDate = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.date, document, row++, column); row++;
		GUIElementComponent seAuthor = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.author, document, row++, column); row++;
		row = 1; column++;
		GUIElementComponent seOrigID = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.orginalId, document, row++, column); row++;
		GUIElementComponent seObject = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.object, document, row++, column); row++;
		GUIElementComponent seCoverage = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.coverage, document, row++, column); row++;
		GUIElementComponent seTemplate = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.template, new GUIComboWidget(), new GUICollectionInput(), row++, column); row++;
		GUIComponentBinding.create(document, GUISlotEditorKind.get(seTemplate).element);
		GUIComponentBinding.create(templateSAP.value, GUICollectionInput.get(seTemplate).collection);
		GUIButtonComponent versionBtn = GUIButtonComponent.create(rootPanel, "${Save version}");
		GUIComponentBinding.create(versionBtn.click, versionPanel.show);
		TemplateFormPanel tfp = new TemplateFormPanel(table, seTemplate.value);
	}
	protected GUIContainerComponent getDynamicContents(IElement el) {
		GUIPanelComponent gpc = rootPanel;
		Template t = (Template) el;
		GUIBufferComponent templateBuffer = GUIBufferComponent.create(gpc, true, t);
		int row = 0; column = 0;
		for (Attribute a : t.attributes.read()) {
			GUIBufferComponent attBuffer = GUIBufferComponent.create(gpc, true, a);
			GUILabelComponent.create(gpc, a.label.val(), row, column++).styleName.set(Text.fromString("formLabel"));
			GUIElementComponent.createSlotEditor(table, Attribute.PROPERTIES.value, attBuffer, row, column++);
			if (column == 4) {
				column = 0; row++;
			}
		}
		return gpc;
	}
}