﻿public class DocumentStandardPropertiesFragment extends Fragment {
	private ISlot<Text> document;
	private GUIPanelComponent versionPanel;
	public DocumentStandardPropertiesFragment(GUIPanelComponent rootPanel, ISlot<Text> document, GUIPanelComponent versionPanel) {
		super(rootPanel);
		this.document = document;
		this.versionPanel = versionPanel;
		init();
	}
	private void init() {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		GUIFindAllInstancesSAPComponent tagSAP = GUIFindAllInstancesSAPComponent.create(table, Tag.FQ_TYPE_NAME);
		GUIFindAllInstancesSAPComponent langSAP = GUIFindAllInstancesSAPComponent.create(table, Language.FQ_TYPE_NAME);
		int row = 0, column = 0;
		GUILabelComponent.create(table, "${Path}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${ID}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Title}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Worklflow Status}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Version}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${File}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Size}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Created On}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Published On}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Created By}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Published By}", row++, column).styleName.set(Text.fromString("formLabel"));
		row = 0; column++;
		GUISingleElementComponent sePath = GUISingleElementComponent.create(table, row++, column);
		GUIComponentBinding.create(document, sePath.element);
		GUIElementComponent seID = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.id, document, row++, column);
		GUISlotEditorKind.get(seID).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seID).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent seTitle = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.title, document, row++, column);
		GUIComponentBinding.create(GUIFieldWidget.get(seTitle).focusLost, versionPanel.show);
		GUIElementComponent seWfStatus = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.wfStatus, document, row++, column);
		GUISlotEditorKind.get(seWfStatus).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seWfStatus).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent seVersion = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.version, document, row++, column);
		GUISlotEditorKind.get(seVersion).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seVersion).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent seFile = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.fileName, document, row++, column);
		GUISlotEditorKind.get(seFile).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seFile).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent seSize = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.fileSize, document, row++, column);
		GUISlotEditorKind.get(seSize).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seSize).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent seCreatedOn = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.createdOn, document, row++, column);
		GUISlotEditorKind.get(seCreatedOn).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seCreatedOn).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent sePublishedOn = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.publishedOn, document, row++, column);
		GUISlotEditorKind.get(sePublishedOn).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(sePublishedOn).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent seCreatedBy = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.createdBy, document, row++, column);
		GUISlotEditorKind.get(seCreatedBy).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seCreatedBy).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent sePublishedBy = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.publishedBy, document, row++, column);
		GUISlotEditorKind.get(sePublishedBy).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(sePublishedBy).displayAsLabel.set(Boolean.TRUE);
		row = 1; column++;
		GUILabelComponent.create(table, "${Vote}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Custom ID}", row++, column).styleName.set(Text.fromString("boldFormLabel"));
		GUILabelComponent.create(table, "${Language}", row++, column).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Tag}", row++, column).styleName.set(Text.fromString("formLabel"));
		row = 1; column++;
		GUIPanelComponent votePic = GUIFactory.createFileComponent(Document.PROPERTIES.rating, false, false, table, null);
		TableLayoutData.setRowColumn(votePic, row++, column);
		GUIComponentBinding.create(document, votePic.input);
		GUIElementComponent seCustomID = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.customID, document, row++, column);
		GUIElementComponent seLanguage = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.language, document, row++, column);
		GUIElementComponent tags = GUIElementComponent.createInput(table, new GUIComboWidget(), new GUICollectionInput(), row++, column);
		GUIComponentBinding.create(document, GUISlotEditorKind.get(seLanguage).element);
		GUIComponentBinding.create(langSAP.value, GUICollectionInput.get(seLanguage).collection);
		GUIComponentBinding.create(tagSAP.value, GUICollectionInput.get(tags).collection);
		GUIComponentBinding.create(GUIFieldWidget.get(seCustomID).focusLost, versionPanel.show);
		GUIComponentBinding.create(GUIComboWidget.get(seLanguage).focusLost, versionPanel.show);
		GUICommandComponent tagCmd = GUICommandComponent.create(rootPanel, new AddTagCommand(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(tags.value, tagCmd, AddTagCommand.PROPERTIES.tag);
		GUIComponentBinding.create(document, tagCmd, AddTagCommand.PROPERTIES.doc);
		GUIComponentBinding.create(GUIFieldWidget.get(tags).focusLost, tagCmd.click);
		TagDynamicPanel tdp = new TagDynamicPanel(table, document);
		GUIComponentBinding.create(tagCmd.commandExecuted, tdp.refreshContents);
		GUIComponentBinding.create(tagCmd.commandExecuted, tags.clearValue);
	}
	protected GUIContainerComponent getDynamicContents(IElement el) {
		GUIPanelComponent gpc = GUIPanelComponent.createTable(rootPanel);
		Document d = (Document) el;
		GUIBufferComponent docBuffer = GUIBufferComponent.create(gpc, true, d);
		int row = 0;
		for (Tag t : d.tags.read()) {
			GUIBufferComponent tagBuffer = GUIBufferComponent.create(gpc, true, t);
			GUILabelComponent.create(gpc, t.name.val(), row, 0).styleName.set(Text.fromString("formLabel"));
			GUIButtonComponent remBtn = GUIButtonComponent.create(gpc, null, DynamicPanelCommands.removeTag, row++, 1);
			GUIComponentBinding.create(docBuffer, remBtn, RemoveTagCommand.PROPERTIES.doc);
			GUIComponentBinding.create(tagBuffer, remBtn, RemoveTagCommand.PROPERTIES.tag);
		}
		return gpc;
	}
}