﻿public class UserPropertiesFragment extends Fragment {	
	private ISlot<Text> user;
	private ISlot<Text> isAdmin;
	private boolean readonly;
	public CompanyGeneralDetailsFragment(GUIPanelComponent rootPanel, ISlot<Text> user, ISlot<Text> isAdmin, boolean readonly) {
		super(rootPanel);
		this.user = user;
		this.isAdmin = isAdmin;
		this.readonly = readonly;
		init();
	}
	private void init() {
		GUIPanelComponent idiv = GUIPanelComponent.createFlow(rootPanel);
		GUILabelComponent.create(idiv, "${ID}").styleName.set(Text.fromString("floatLabel"));
		GUIElementComponent seId = GUIElementComponent.createSlotEditor(idiv, User.PROPERTIES.id, user);
		displayAsLabel(seId);	
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		GUIFindAllInstancesSAPComponent langSAP = GUIFindAllInstancesSAPComponent.create(table, Language.FQ_TYPE_NAME);
		GUIFindAllInstancesSAPComponent groupSAP = GUIFindAllInstancesSAPComponent.create(table, Group.FQ_TYPE_NAME);
		int row = 1, column = 0;
		GUILabelComponent.create(table, "${Username}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${First Name}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Language}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Postal Code}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Country}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Phone}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		row = 1; column++;
		GUILabelComponent.create(table, "${Email}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Last Name}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Address}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${City}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${State}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		GUILabelComponent.create(table, "${Mobile}", row++, column).styleName.set(Text.fromString("formLabel")); row++;
		row = 0; column = 0;
		GUIElementComponent seEnabled = GUIElementComponent.createSlotEditorCheckbox(table, User.PROPERTIES.enabled, user, "${Enabled}", null);
		GUIComponentBinding.create(isAdmin, seEnabled.enabled);
		TableLayoutData.setRowColumn(seEnabled, row++, column); row++;
		GUIElementComponent seUsername = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.username, user, row++, column); row++;
		GUIElementComponent seFirstName = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.firstName, user, row++, column); row++;
		GUIElementComponent seLanguage = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.language, new GUIComboWidget(), new GUICollectionInput(), row++, column); row++;
		GUIElementComponent sePostalCode = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.postalCode, user, row++, column); row++;
		GUIElementComponent seCountry = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.country, user, row++, column); row++;
		GUIElementComponent sePhone = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.phone, user, row++, column); row++;
		row = 0; column++;
		GUIElementComponent sePasswordExp = GUIElementComponent.createSlotEditorCheckbox(table, User.PROPERTIES.passExpires, user, "${Password expires}", null);
		TableLayoutData.setRowColumn(sePasswordExp, row++, column); row++;
		GUIElementComponent seEmail = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.email, user, row++, column); row++;
		GUIElementComponent seLastName = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.lastName, user, row++, column); row++;
		GUIElementComponent seAddress = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.address, user, row++, column); row++;
		GUIElementComponent seCity = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.city, user, row++, column); row++;
		GUIElementComponent seState = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.state, user, row++, column); row++;
		GUIElementComponent seMobile = GUIElementComponent.createSlotEditor(table, User.PROPERTIES.mobile, user, row++, column); row++;
		GUIComponentBinding.create(user, GUISlotEditorKind.get(seEnabled).element);
		GUIComponentBinding.create(langSAP.value, GUICollectionInput.get(seLanguage).collection);
		GUIPanelComponent groupPanel = GUIPanelComponent.createTable(rootPanel);
		groupPanel.styleName.set(Text.fromString("rightPanel"));
		GUILabelComponent.create(table, "${Add Group}", 0, 0).styleName.set(Text.fromString("formLabel"));
		GUIElementComponent groups = GUIElementComponent.createInput(groupPanel, new GUIComboWidget(), new GUICollectionInput(), 0, 1);
		GUIComponentBinding.create(groupSAP.value, GUICollectionInput.get(groups).collection);
		GUICommandComponent groupCmd = GUICommandComponent.create(rootPanel, new AddGroupCommand(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(groups.value, groupCmd, AddGroupCommand.PROPERTIES.group);
		GUIComponentBinding.create(user, groupCmd, AddGroupCommand.PROPERTIES.doc);
		GUIComponentBinding.create(GUIFieldWidget.get(groups).focusLost, groupCmd.click);
		GroupDynamicPanel gdp = new GroupDynamicPanel(table, user);
		GUIComponentBinding.create(groupCmd.commandExecuted, gdp.refreshContents);
		GUIComponentBinding.create(groupCmd.commandExecuted, groups.clearValue);
		if (readonly) {
			displayAsLabel(seEnabled);
			displayAsLabel(seUsername);
			displayAsLabel(seFirstName);
			displayAsLabel(seLanguage);
			displayAsLabel(sePostalCode);
			displayAsLabel(seCountry);
			displayAsLabel(sePhone);
			displayAsLabel(sePasswordExp);
			displayAsLabel(seEmail);
			displayAsLabel(seLastName);
			displayAsLabel(seAddress);
			displayAsLabel(seCity);
			displayAsLabel(seState);
			displayAsLabel(seMobile);
		}
	}
	private displayAsLabel(GUIElementComponent slotEditor) {
		GUISlotEditorKind.get(slotEditor).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(slotEditor).displayAsLabel.set(Boolean.TRUE);	
	}
	protected GUIContainerComponent getDynamicContents(IElement el) {
		GUIPanelComponent gpc = GUIPanelComponent.createTable(rootPanel);
		User u = (User) el;
		GUIBufferComponent userBuffer = GUIBufferComponent.create(gpc, true, u);
		int row = 0;
		for (Group g : u.groups.read()) {
			GUIBufferComponent groupBuffer = GUIBufferComponent.create(gpc, true, g);
			GUILabelComponent.create(gpc, g.name.val(), row, 0).styleName.set(Text.fromString("formLabel"));
			GUIButtonComponent remBtn = GUIButtonComponent.create(gpc, null, DynamicPanelCommands.removeGroup, row++, 1);
			GUIComponentBinding.create(userBuffer, remBtn, RemoveGroupCommand.PROPERTIES.usr);
			GUIComponentBinding.create(groupBuffer, remBtn, RemoveGroupCommand.PROPERTIES.group);
		}
		return gpc;
	}
}