public class ManufacturerDetailsFragment extends ResetableFragment {
	public ISlot<Text> manufacturer;
	public ManufacturerDetailsFragment(GUIPanelComponent rootPanel, ISlot<Text> manufacturer) {
		super(rootPanel);
		this.manufacturer = manufacturer;
		init();
	}
	private void init() {
		GUIImageComponent.create(rootPanel, "img/manufacturer.png").styleName.set(Text.fromString("headingicon"));
		GUILabelComponent.create(rootPanel, "${Edit Manufacturer Details}").styleName.set(Text.fromString("subtitle"));
		GUICollectionInput gci = new GUICollectionInput();
		GUIElementComponent nameTitle = GUIElementComponent.createInput(rootPanel, new GUIListWidget(), gci);
		GUIComponentBinding.create(manufacturer, GUICollectionInput.get(nameTitle).collection);
		nameTitle.styleName.set(Text.fromString("objecttitle"));
		GUIButtonComponent back = GUIButtonComponent.create(rootPanel, "${back to manufacturers}", null, null, true);
		GUIComponentBinding.create(back.click, rootPanel.parent.val().back);
		GUITabComponent tabs = GUITabComponent.create(rootPanel, "${Manufacturer Info}", "${SEO}", "${Products}");
		GUIPanelComponent t1 = GUIPanelComponent.createFlow(tabs);
		GUIPanelComponent t2 = GUIPanelComponent.createFlow(tabs);
		GUIPanelComponent t3 = GUIPanelComponent.createFlow(tabs);
		info(t1, manufacturer);
		seo(t2, manufacturer);
		new ManufacturersProductsDynamicPanel(t3, manufacturer);
		GUIPanelComponent rightAlign = GUIPanelComponent.createFlow(rootPanel);
		rightAlign.styleName.set(Text.fromString("rightAlign"));
		DestroyProject cmdDestroyProject = new DestroyProject();
		GUIButtonComponent btnDeleteProject = GUIButtonComponent.create(rightAlign, "${ProjectDetailsFragment.label10}", cmdDestroyProject);
		btnDeleteProject.confirmationRequired.set(Boolean.TRUE);
		btnDeleteProject.confirmationMessage.set(Text.fromString("${ProjectDetailsFragment.label11}"));
		GUIComponentBinding.create(manufacturer, btnDeleteProject, DestroyProject.PROPERTIES.project);
	}
	private void info(GUIPanelComponent rootPanel, ISlot<Text> manufacturer) {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		table.styleName.set(Text.fromString("table"));
		int row = 0;
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Name}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Description}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Category template:}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Picture}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Parent category}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Price ranges}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Show on home page}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Published}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Display order}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIElementComponent seName = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.name, manufacturer);
		GUIElementComponent seDesc = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.description, manufacturer);
		GUIFieldWidget.get(seDesc).isHTML.set(Boolean.TRUE);
		GUIElementComponent seTemplate = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.template, manufacturer);
		GUIPanelComponent seImage = GUIFactory.createFileComponent(Manufacturer.PROPERTIES.image, true, true, table, null);
		GUIComponentBinding.create(manufacturer, seImage.input);
		GUIFindAllInstancesSAPComponent categories = GUIFindAllInstancesSAPComponent.create(rootPanel, Manufacturer.FQ_TYPE_NAME);
		GUIElementComponent seParent = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.company, new GUISuggestWidget(), new GUICollectionInput(), null);
		GUIComponentBinding.create(categories.value, GUICollectionInput.get(seParent).collection);
		GUIComponentBinding.create(manufacturer, GUISlotEditorKind.get(seParent).element);
		GUIComponentBinding.create(rootPanel.input, categories.refresh);
		GUIElementComponent sePriceRange = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.priceRange, manufacturer);
		GUIElementComponent seShowOnHome = GUIElementComponent.createSlotEditorCheckbox(table, Manufacturer.PROPERTIES.showOnHome, manufacturer, "", null);
		GUIElementComponent sePublished = GUIElementComponent.createSlotEditorCheckbox(table, Manufacturer.PROPERTIES.isPublished, manufacturer, "", null);
		GUIElementComponent seDispOrder = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.dispOrder, manufacturer);
		row = 0;
		TableLayoutData.setRowColumn(seName, row++, 2);
		TableLayoutData.setRowColumn(seDesc, row++, 2);
		TableLayoutData.setRowColumn(seTemplate, row++, 2);
		TableLayoutData.setRowColumn(seImage, row++, 2);
		TableLayoutData.setRowColumn(seParent, row++, 2);
		TableLayoutData.setRowColumn(sePriceRange, row++, 2);
		TableLayoutData.setRowColumn(seShowOnHome, row++, 2);
		TableLayoutData.setRowColumn(sePublished, row++, 2);
		TableLayoutData.setRowColumn(seDispOrder, row++, 2);
	}
	private void seo(GUIPanelComponent rootPanel, ISlot<Text> manufacturer) {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		table.styleName.set(Text.fromString("table"));
		int row = 0;
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Meta keywords}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Meta Description}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Meta title}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Search engine friendly page names}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent.create(table, "/img/helper.ico", row++, 0).tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent.create(table, "${Allow customers to select page size}", row, 1).styleName.set(Text.fromString("formLabel"));
		GUIImageComponent sePageSizeHelper = GUIImageComponent.create(table, "/img/helper.ico", row++, 0);
		sePageSizeHelper.tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent sePageSizeLabel = GUILabelComponent.create(table, "${Page Size}", row, 1);
		sePageSizeLabel.styleName.set(Text.fromString("formLabel"));
		GUIImageComponent sePageSizeOptionsHelper = GUIImageComponent.create(table, "/img/helper.ico", row++, 0);
		sePageSizeOptionsHelper.tooltip.set(Text.fromString("Some explanation..."));
		GUILabelComponent sePageSizeOptionsLabel = GUILabelComponent.create(table, "${Page Size options (comma separated)}", row, 1);
		sePageSizeOptionsLabel.styleName.set(Text.fromString("formLabel"));
		GUIElementComponent seMetaKey = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.metaKeywords, manufacturer);
		GUIElementComponent seMetaDesc = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.metaDescription, manufacturer);
		GUIElementComponent seMetaTitle = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.metaTitle, manufacturer);
		GUIElementComponent seSEO = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.seo, manufacturer);
		GUIElementComponent seAllowCustomPageSize = GUIElementComponent.createSlotEditorCheckbox(table, Manufacturer.PROPERTIES.allowCustomPageSize, manufacturer, "", null);
		GUIElementComponent sePageSize = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.pageSize, manufacturer);
		GUIElementComponent sePageSizeOptions = GUIElementComponent.createSlotEditor(table, Manufacturer.PROPERTIES.pageSizeOption, manufacturer);
		GUINotGate gng = GUINotGate.create(rootPanel, seAllowCustomPageSize.value);
		GUIComponentBinding.create(seAllowCustomPageSize.value, sePageSizeOptions.visible);
		GUIComponentBinding.create(seAllowCustomPageSize.value, sePageSizeOptionsLabel.visible);
		GUIComponentBinding.create(seAllowCustomPageSize.value, sePageSizeOptionsHelper.visible);
		GUIComponentBinding.create(gng.output, sePageSize.visible);
		GUIComponentBinding.create(gng.output, sePageSizeLabel.visible);
		GUIComponentBinding.create(gng.output, sePageSizeHelper.visible);
		row = 0;
		TableLayoutData.setRowColumn(seMetaKey, row++, 2);
		TableLayoutData.setRowColumn(seMetaDesc, row++, 2);
		TableLayoutData.setRowColumn(seMetaTitle, row++, 2);
		TableLayoutData.setRowColumn(seSEO, row++, 2);
		TableLayoutData.setRowColumn(seAllowCustomPageSize, row++, 2);
		TableLayoutData.setRowColumn(sePageSize, row++, 2);
		TableLayoutData.setRowColumn(sePageSizeOptions, row++, 2);
	}
	private void setReadOnly(GUIElementComponent gec) {
		GUISlotEditorKind.get(gec).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(gec).displayAsLabel.set(Boolean.TRUE);
	}
	private void manufacturerProductsDynamicPanel(GUIPanelComponent rootPanel, ISlot<Text> manufacturer) {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		GUILabelComponent.create(table, "${Product}", 0, 0).styleName.set(Text.fromString("header"));
		GUILabelComponent.create(table, "${Is featured product?}", 0, 1).styleName.set(Text.fromString("header"));
		GUILabelComponent.create(table, "${Display order}", 0, 2).styleName.set(Text.fromString("header"));
		GUILabelComponent.create(table, "", 0, 3).styleName.set(Text.fromString("header"));
		int row = 1;
		RemoveProduct rp = new RemoveProduct();
		for (Product p : manufacturer.val().products.read()) {
			GUIBufferComponent pbuf = GUIBufferComponent.create(rootPanel, true, p);
			GUIElementComponent seName = GUIElementComponent.createSlotEditor(table, Product.PROPERTIES.name, manufacturer, row, 0);
			setReadOnly(seName);
			GUIPanelComponent isfeaturedWrap = GUIPanelComponent.createFlow(table);
			TableLayoutData.setRowColumn(isfeaturedWrap, row, 1);
			GUIElementComponent seIsFeatured = GUIElementComponent.createSlotEditor(isfeaturedWrap, Product.PROPERTIES.isFeatured, manufacturer);
			seIsFeatured.visible.set(Boolean.FALSE);
			GUIElementComponent seIsFeaturedReadOnly = GUIElementComponent.createSlotEditor(isfeaturedWrap, Product.PROPERTIES.isFeatured, manufacturer);
			setReadOnly(seIsFeaturedReadOnly);
			GUIPanelComponent orderWrap = GUIPanelComponent.createFlow(table);
			TableLayoutData.setRowColumn(orderWrap, row, 2);
			GUIElementComponent seOrder = GUIElementComponent.createSlotEditor(orderWrap, Product.PROPERTIES.order, manufacturer);
			seOrder.visible.set(Boolean.FALSE);
			GUIElementComponent seOrderReadOnly = GUIElementComponent.createSlotEditor(orderWrap, Product.PROPERTIES.order, manufacturer);
			setReadOnly(seOrderReadOnly);
			GUIBufferComponent unVisibleBuf = GUIBufferComponent.create(rootPanel, Boolean.FALSE);
			GUIBufferComponent notunVisibleBuf = GUINotGate.create(rootPanel, unVisibleBuf.output);
			GUIBufferComponent visibleBuf = GUIBufferComponent.create(rootPanel, Boolean.TRUE);
			GUIBufferComponent notVisibleBuf = GUINotGate.create(rootPanel, visibleBuf.output);
			GUIComponentBinding.create(unVisibleBuf.output, seIsFeaturedReadOnly.visible);
			GUIComponentBinding.create(unVisibleBuf.output, seOrderReadOnly.visible);
			GUIComponentBinding.create(visibleBuf.output, seIsFeatured.visible);
			GUIComponentBinding.create(visibleBuf.output, seOrder.visible);
			GUIComponentBinding.create(notunVisibleBuf.output, seIsFeaturedReadOnly.visible);
			GUIComponentBinding.create(notunVisibleBuf.output, seOrderReadOnly.visible);
			GUIComponentBinding.create(notVisibleBuf.output, seIsFeatured.visible);
			GUIComponentBinding.create(notVisibleBuf.output, seOrder.visible);
			GUIPanelComponent buttons = GUIPanelComponent.createFlow(table, row, 3);
			GUIButtonComponent done = GUIButtonComponent.create(table, "${Done}", rp);
			GUIComponentBinding.create(done.click, notVisibleBuf.send);
			GUIComponentBinding.create(done.click, notunVisibleBuf.send);
			GUIComponentBinding.create(notVisibleBuf.output, done.visible);
			GUIButtonComponent edit = GUIButtonComponent.create(table, "${Edit}", rp);
			GUIComponentBinding.create(edit.click, visibleBuf.send);
			GUIComponentBinding.create(edit.click, unVisibleBuf.send);
			GUIComponentBinding.create(unVisibleBuf.output, edit.visible);
			GUIButtonComponent delete = GUIButtonComponent.create(table, "${Delete}", rp);
			GUIComponentBinding.create(pbuf.output, delete, RemoveProduct.PROPERTIES.product);
			GUIComponentBinding.create(manufacturer, delete, RemoveProduct.PROPERTIES.manufact);
			row++;
		}
		GUIButtonComponent refresh = GUIButtonComponent.create(rootPanel, "${Refresh}");
		GUIComponentBinding.create(refresh.click, this.refresh);
		GUIButtonComponent addNew = GUIButtonComponent.create(rootPanel, "${AddProduct}");
		GUIComponentBinding.create(addNew.click, addNewProductFragment.show);
	}
}