﻿public class DocumentDetailsFragment extends Fragment {
	private ISlot<Text> doc;
	public PartyContactDetailsFragment(GUIPanelComponent rootPanel, ISlot<Text> doc) {
		super(rootPanel);
		this.doc = doc;
		init();
	}
	private void init() {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		table.styleName.set(Text.fromString("table"));
		int row = 0;
		GUILabelComponent.create(table, "${UUID}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Name}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Folder}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Size}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Created}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Modified}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${MIME type}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Keywords}", row++, 0).styleName.set(Text.fromString("formLabel"));
		row++;
		GUILabelComponent.create(table, "${Status}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Subscribed}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${History size}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${URL}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${WebDAV}", row++, 0).styleName.set(Text.fromString("formLabel"));
		row = 0;
		GUILabelComponent.create(table, "${Subscribed users}", row++, 2).styleName.set(Text.fromString("formLabel"));
		row++;
		GUILabelComponent.create(table, "${Keywords cloud}", row++, 2).styleName.set(Text.fromString("formLabel"));
		row++;
		GUILabelComponent.create(table, "${Categories}", row++, 2).styleName.set(Text.fromString("formLabel"));
		GUIElementComponent seUUID = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.uuid, doc);
		GUIElementComponent seName = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.name, doc);
		GUIElementComponent seFolder = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.folder, doc);
		GUIElementComponent seSize = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.created, doc);
		GUIPanelComponent createdPanel = GUIPanelComponent.createFlow(table);
		GUIElementComponent seCreated = GUIElementComponent.createSlotEditor(createdPanel, Document.PROPERTIES.created, doc);
		GUILabelComponent.create(createdPanel, "${ by }");
		GUIElementComponent seCreatedByUser = GUIElementComponent.createSlotEditor(createdPanel, Document.PROPERTIES.createdByUser, doc);
		GUIPanelComponent modifiedPanel = GUIPanelComponent.createFlow(table);
		GUIElementComponent seModified = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.modified, doc);
		GUILabelComponent.create(createdPanel, "${ by }");
		GUIElementComponent seModifiedByUser = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.modifiedByUser, doc);
		GUIElementComponent seMime = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.mime, doc);
		GUIPanelComponent keywordsPanel = GUIPanelComponent.createFlow(table);
		GUIFindAllInstancesSAPComponent keywords = GUIFindAllInstancesSAPComponent.create(keywordsPanel, Keyword.FQ_TYPE_NAME);
		GUIElementComponent suggestKeyword = GUIElementComponent.createInput(keywordsPanel, new GUISuggestWidget(), new GUICollectionInput(), null);
		GUISuggestWidget.get(suggestKeyword).showSuggestionsOnFocus.set(Boolean.FALSE);
		GUIComponentBinding.create(keywords.value, GUICollectionInput.get(suggestKeyword).collection);
		GUICommandComponent addKeyword = GUICommandComponent.create(keywordsPanel, new AddKeyword(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(doc, addKeyword, AddKeyword.PROPERTIES.document);
		GUIComponentBinding.create(suggestKeyword.value, addKeyword, AddPersonToCompany.PROPERTIES.keyword);
		GUIComponentBinding.create(suggestKeyword.value, addKeyword.click);
		ThesaurusFragment tf = new ThesaurusFragment(rootPanel.getApplication());
		GUIButtonComponent thesaurus = GUIButtonComponent.create(keywordsPanel, "");
		thesaurus.styleName.set(Text.fromString("thesaurusImageButton"));
		GUIComponentBinding.create(thesaurus.click, tf.show);
		KeywordsDynamicPanel kdp = new KeywordsDynamicPanel(table, doc);
		GUIComponentBinding.create(doc, kdp.element);
		GUIComponentBinding.create(rootPanel.input, kdp.refreshContents);
		GUIComponentBinding.create(addKeyword.commandExecuted, kdp.refreshContents);
		GUIElementComponent seStatus = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.status, doc);
		GUIElementComponent seSubscribed = GUIElementComponent.createSlotEditor(table, Document.PROPERTIES.subscribed, doc);
		GUILabelComponent historySize = GUILabelComponent.create(table, "");
		GUICommandComponent cmdHistorySize = GUICommandComponent.create(rootPanel, new GetHistorySize(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(doc, cmdHistorySize, GetHistorySize.PROPERTIES.document);
		GUIComponentBinding.create(cmdHistorySize, GetHistorySize.PROPERTIES.result, historySize.label);
		CopyToClipboardFragment ctcf = new CopyToClipboardFragment(table, Document.PROPERTIES.url, doc);
		CopyToClipboardFragment ctcf2 = new CopyToClipboardFragment(table, Document.PROPERTIES.webdav, doc);
		SubscribeFragment sf = new SubscribeFragment(rootPanel.getApplication());
		GUIButtonComponent subscriptionButton = GUIButtonComponent.create(table, "");
		subscriptionButton.styleName.set(Text.fromString("subscribeImageButton"));
		GUIComponentBinding.create(subscriptionButton.click, sf.show);
		GUIElementComponent subscribersList = GUIElementComponent.createInput(table, new GUIListWidget(), GUISlotValueInput.create(Document.PROPERTIES.subscribers));
		GUIComponentBinding.create(doc, GUISlotValueInput.get(subscribersList).element);
		KeywordsCloudFragment kcf = new KeywordsCloudFragment(table);
		GUIComponentBinding.create(doc, kcf.element);
		GUIComponentBinding.create(rootPanel.input, kcf.refreshContents);
		GUIComponentBinding.create(addKeyword.commandExecuted, kcf.refreshContents);
		CategoriesFragment cf = new CategoriesFragment(rootPanel.getApplication());
		GUIButtonComponent categoryButton = GUIButtonComponent.create(table, "");
		categoryButton.styleName.set(Text.fromString("categoryImageButton"));
		GUIComponentBinding.create(categoryButton.click, cf.show);
		CategoriesDynamicPanel cdp = new CategoriesDynamicPanel(table);
		GUIComponentBinding.create(doc, cdp.element);
		GUIComponentBinding.create(rootPanel.input, cdp.refreshContents);
		GUIComponentBinding.create(cf.refresh, cdp.refreshContents);
		TableLayoutData.setRowColumn(seUUID, row++, 1);
		TableLayoutData.setRowColumn(seName, row++, 1);
		TableLayoutData.setRowColumn(seFolder, row++, 1);
		TableLayoutData.setRowColumn(seSize, row++, 1);
		TableLayoutData.setRowColumn(createdPanel, row++, 1);
		TableLayoutData.setRowColumn(modifiedPanel, row++, 1);
		TableLayoutData.setRowColumn(seMime, row++, 1);
		TableLayoutData.setRowColumn(keywordsPanel, row++, 1);
		TableLayoutData.setRowColumn(kdp, row++, 1);
		TableLayoutData.setRowColumn(seStatus, row++, 1);
		TableLayoutData.setRowColumn(seSubscribed, row++, 1);
		TableLayoutData.setRowColumn(historySize, row++, 1);
		TableLayoutData.setRowColumn(ctcf, row++, 1);
		TableLayoutData.setRowColumn(ctcf2, row++, 1);
		row = 0;
		TableLayoutData.setRowColumn(subscriptionButton, row++, 3);
		TableLayoutData.setRowColumn(subscribersList, row++, 2);
		row++;
		TableLayoutData.setRowColumn(kcf, row++, 2);
		TableLayoutData.setRowColumn(categoryButton, row++, 3);
		TableLayoutData.setRowColumn(cdp, row++, 3);
		checkSetVisibility();
		setAllReadonly();
	}
	private void checkSetVisibility() {
		GUICommandComponent checkPermisions = GUICommandComponent.create(rootPanel, new CheckPermisions(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(doc, checkPermisions, checkPermisions.PROPERTIES.document);
		GUIComponentBinding.create(checkPermisions, checkPermisions.PROPERTIES.visible, subscriptionButton.visible);
		GUIComponentBinding.create(checkPermisions, checkPermisions.PROPERTIES.visible, categoryButton.visible);
		GUIComponentBinding.create(checkPermisions, checkPermisions.PROPERTIES.visible, categoryButton.visible);
		GUIComponentBinding.create(checkPermisions, checkPermisions.PROPERTIES.visible, kdp.readonly);
		GUIComponentBinding.create(checkPermisions, checkPermisions.PROPERTIES.visible, cdp.readonly);
	}
	private void setAllReadonly(GUIELmentComponent gec) {
		setReadonly(seUUID);
		setReadonly(seName);
		setReadonly(seFolder);
		setReadonly(seSize);
		setReadonly(seCreatedByUser);
		setReadonly(seModifiedByUser);
		setReadonly(seMime);
		setReadonly(seStatus);
		setReadonly(seSubscribed);
	}
	private void setReadonly(GUIElementComponent gec) {
		GUISlotEditorKind.get(gec).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(gec).displayAsLabel.set(Boolean.TRUE);
	}
}
	protected GUIContainerComponent getDynamicContents(IElement el) { // for keywords panel
		GUIPanelComponent gpc = GUIPanelComponent.createFlow(null);
		gpc.styleName.set(Text.fromString("fancyFloat"));
		List<Keyword> keywords;
		if (el instanceof Document) {
			keywords = ((Document) el).keywords.read();
		} else {
			return gpc;
		}		
		ObjectOfClass doc = (ObjectOfClass) el;
		GUIBufferComponent documentBuffer = GUIBufferComponent.create(gpc, true, doc);
		for (Keyword k : keywords) {
			GUIPanelComponent keyDiv = GUIPanelComponent.createFlow(gpc);
			GUIBufferComponent keywordBuffer = GUIBufferComponent.create(gpc, true, k);
			keyDiv.styleName.set(Text.fromString("grayKeywordBox"));
			GUILabelComponent.create(keyDiv, k.value()).styleName.set(Text.fromString("keywordLabel"));
			if (!readonly.val().toBoolean()) {
				GUIButtonComponent btnRem = GUIButtonComponent.create(picDiv, " ", DynamicPanelCommands.removeKeyword);
				btnRem.styleName.set(Text.fromString("delBtn"));
				GUIComponentBinding.create(documentBuffer.output, btnRem, RemoveKeyword.PROPERTIES.document);
				GUIComponentBinding.create(keywordBuffer.output, btnRem, RemoveKeyword.PROPERTIES.keyword);
				GUIComponentBinding.create(btnRem.commandExecuted, refreshContents);				
			}
		}
		return gpc;
	}
	protected GUIContainerComponent getDynamicContents(IElement el) { // for category panel
		GUIPanelComponent gpc = GUIPanelComponent.createFlow(null);
		gpc.styleName.set(Text.fromString("fancyFloat"));
		List<Category> categories;
		if (el instanceof Document) {
			categories = ((Document) el).categories.read();
		} else {
			return gpc;
		}		
		ObjectOfClass doc = (ObjectOfClass) el;
		GUIBufferComponent documentBuffer = GUIBufferComponent.create(gpc, true, doc);
		for (Category k : categories) {
			GUIPanelComponent catDiv = GUIPanelComponent.createFlow(gpc);
			GUIBufferComponent categoryBuffer = GUIBufferComponent.create(gpc, true, k);
			catDiv.styleName.set(Text.fromString("catItem"));
			if (k.hasChildren()) {
				GUIImageComponent.create(catDiv, "img/menuitem_children.gif"));
			} else {
				GUIImageComponent.create(catDiv, "img/menuitem_children.gif"));
			}
			GUISingleElementComponent cat = GUISingleElementComponent.create(catDiv);
			GUICompoenentBinding.create(categoryBuffer.output, cat.element);
			if (!readonly.val().toBoolean()) {
				GUIButtonComponent btnRem = GUIButtonComponent.create(picDiv, " ", DynamicPanelCommands.removeCategory);
				btnRem.styleName.set(Text.fromString("delBtn"));
				GUIComponentBinding.create(documentBuffer.output, btnRem, RemoveCategory.PROPERTIES.document);
				GUIComponentBinding.create(categoryBuffer.output, btnRem, RemoveCategory.PROPERTIES.keyword);
				GUIComponentBinding.create(btnRem.commandExecuted, refreshContents);				
			}
		}
		return gpc;
	}