﻿public class FolderDetailsFragment extends Fragment {
	private ISlot<Text> folder;
	public FolderDetailsFragment(GUIPanelComponent rootPanel, ISlot<Text> folder) {
		super(rootPanel);
		this.folder = folder;
		init();
	}
	private void init() {
		GUIPanelComponent table = GUIPanelComponent.createTable(rootPanel);
		table.styleName.set(Text.fromString("table"));
		int row = 0;
		GUILabelComponent.create(table, "${UUID}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Name}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Parent}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Created}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Subscribed}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Folders}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Documents}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${Mails}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${URL}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(table, "${WebDAV}", row++, 0).styleName.set(Text.fromString("formLabel"));
		row = 0;
		GUILabelComponent.create(table, "${Subscribed users}", row++, 2).styleName.set(Text.fromString("formLabel"));
		GUIElementComponent seUUID = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.uuid, folder);
		GUIElementComponent seName = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.name, folder);
		GUIElementComponent seParent = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.parent, folder);
		GUIPanelComponent createdPanel = GUIPanelComponent.createFlow(table);
		GUIElementComponent seCreated = GUIElementComponent.createSlotEditor(createdPanel, Folder.PROPERTIES.created, folder);
		GUILabelComponent.create(createdPanel, "${ by }");
		GUIElementComponent seCreatedByUser = GUIElementComponent.createSlotEditor(createdPanel, Folder.PROPERTIES.createdByUser, folder);
		GUIElementComponent seSubscribed = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.subscribed, folder);
		GUIElementComponent seFolders = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.folderNum, folder);
		GUIElementComponent seDocuments = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.docNum, folder);
		GUIElementComponent seMails = GUIElementComponent.createSlotEditor(table, Folder.PROPERTIES.mailNum, folder);
		CopyToClipboardFragment ctcf = new CopyToClipboardFragment(table, Document.PROPERTIES.url, doc);
		CopyToClipboardFragment ctcf2 = new CopyToClipboardFragment(table, Document.PROPERTIES.webdav, doc);
		SubscribeFragment sf = new SubscribeFragment(rootPanel.getApplication());
		GUIButtonComponent subscriptionButton = GUIButtonComponent.create(table, "");
		subscriptionButton.styleName.set(Text.fromString("subscribeImageButton"));
		GUIComponentBinding.create(subscriptionButton.click, sf.show);
		GUIElementComponent subscribersList = GUIElementComponent.createInput(table, new GUIListWidget(), GUISlotValueInput.create(Folder.PROPERTIES.subscribers));
		GUIComponentBinding.create(folder, GUISlotValueInput.get(subscribersList).element);
		TableLayoutData.setRowColumn(seUUID, row++, 1);
		TableLayoutData.setRowColumn(seName, row++, 1);
		TableLayoutData.setRowColumn(seParent, row++, 1);
		TableLayoutData.setRowColumn(createdPanel, row++, 1);
		TableLayoutData.setRowColumn(seSubscribed, row++, 1);
		TableLayoutData.setRowColumn(seFolders, row++, 1);
		TableLayoutData.setRowColumn(seDocuments, row++, 1);
		TableLayoutData.setRowColumn(seMails, row++, 1);
		TableLayoutData.setRowColumn(ctcf, row++, 1);
		TableLayoutData.setRowColumn(ctcf2, row++, 1);
		row = 0;
		TableLayoutData.setRowColumn(subscriptionButton, row++, 3);
		TableLayoutData.setRowColumn(subscribersList, row++, 2);
		setAllReadonly();
	}
	private void setAllReadonly(GUIELmentComponent gec) {
		setReadonly(seUUID);
		setReadonly(seName);
		setReadonly(seParent);
		setReadonly(seCreatedByUser);
		setReadonly(seSubscribed);
		setReadonly(seFolders);
		setReadonly(seDocuments);
		setReadonly(seMails);
	}
	private void setReadonly(GUIElementComponent gec) {
		GUISlotEditorKind.get(gec).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(gec).displayAsLabel.set(Boolean.TRUE);
	}
}