﻿public class UserManagementFragment extends Fragment {
	public ISlot<Text> userAcc;
	public ISlot<Text> show;
	public ISlot<Text> hide;
	private GUIDialogComponent rootPanel;
	public UserManagementFragment(GUIPanelComponent rootPanel, ISlot<Text> userAcc) {
		super(rootPanel);
		this.rootPanel = new GUIDialogComponent();
		this.rootPanel.modal.set(Boolean.TRUE);
		this.rootPanel.application.set(rootPanel.getApplication());
		this.rootPanel.caption.set(Text.fromString("${User Configuration}"));
		this.userAcc = userAcc;
		init();
	}
	private void init() {
		GUIComponentBinding.create(show, rootPanel.show);
		GUIComponentBinding.create(hide, rootPanel.hide);
		GUILabelComponent.create(rootPanel, "${User Account}");
		GUIPanelComponent groupBox = GUIPanelComponent.createFlow(rootPanel);
		groupBox.styleName.set(Text.fromString("groupBox"));
		GUIPanelComponent userTable = GUIPanelComponent.createTable(rootPanel);
		userTable.styleName.set(Text.fromString("table"));
		int row = 0;
		GUILabelComponent.create(userTable, "${User}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(userTable, "${Password}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(userTable, "${Email}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(userTable, "${Roles}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUIElementComponent seUser = GUIElementComponent.createSlotEditor(userTable, Party.PROPERTIES.userName, userAcc);
		GUISlotEditorKind.get(seUser).readOnly.set(Boolean.TRUE);
		GUISlotEditorKind.get(seUser).displayAsLabel.set(Boolean.TRUE);
		GUIElementComponent pass1 = GUIElementComponent.createInput(userTable, GUIFieldWidget.createPasswordText(), null);
		GUIElementComponent pass2 = GUIElementComponent.createInput(userTable, GUIFieldWidget.createPasswordText(), null);
		GUIElementComponent seEmail = GUIElementComponent.createSlotEditor(userTable, Party.PROPERTIES.emailAddress, userAcc);
		GUIElementComponent roles = GUIElementComponent.createInput(userTable, new GUIListWidget(), GUISlotValueInput.create(Party.PROPERTIES.userRoles));
		GUIComponentBinding.create(userAcc, GUISlotValueInput.get(roles).element);
		roles.styleName.set(Text.fromString("simpleList"));
		row = 0;
		TableLayoutData.setRowColumn(seEmail, row++, 1);
		TableLayoutData.setRowColumn(pass1, row, 1);
		TableLayoutData.setRowColumn(pass2, row++, 2);
		TableLayoutData.setRowColumn(seUser, row++, 1);
		TableLayoutData.setRowColumn(roles, row++, 1);
		GUILabelComponent.create(rootPanel, "${Mail Account}");
		GUIPanelComponent groupBox2 = GUIPanelComponent.createFlow(rootPanel);
		groupBox2.styleName.set(Text.fromString("groupBox"));
		GUIPanelComponent mailTable = GUIPanelComponent.createTable(rootPanel);
		mailTable.styleName.set(Text.fromString("table"));
		row = 0;
		GUILabelComponent.create(mailTable, "${IMAP server}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(mailTable, "${IMAP user name}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(mailTable, "${IMAP password}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUILabelComponent.create(mailTable, "${IMAP folder}", row++, 0).styleName.set(Text.fromString("formLabel"));
		GUIElementComponent seImapServer = GUIElementComponent.createSlotEditor(mailTable, Party.PROPERTIES.imapServer, userAcc);
		GUIElementComponent seImapUser = GUIElementComponent.createSlotEditor(mailTable, Party.PROPERTIES.imapUser, userAcc);
		GUIElementComponent seImapPass = GUIElementComponent.createSlotEditor(mailTable, Party.PROPERTIES.imapPass, userAcc);
		GUIElementComponent seImapFolder = GUIElementComponent.createSlotEditor(mailTable, Party.PROPERTIES.imapFolder, userAcc);
		row = 0;
		TableLayoutData.setRowColumn(seImapServer, row++, 1);
		TableLayoutData.setRowColumn(seImapUser, row++, 1);
		TableLayoutData.setRowColumn(seImapPass, row++, 1);
		TableLayoutData.setRowColumn(seImapFolder, row++, 1);
		GUIButtonComponent test = GUIButtonComponent.create(groupBox2, "${Test}", new TestIMAPCmd());
		GUIComponentBinding.create(userAcc, test, TestIMAPCmd.PROPERTIES.userAccount);
		GUIButtonComponent updatePass = GUIButtonComponent.create(rootPanel, "${Update}", new UpdatePassCmd());
		GUIComponentBinding.create(userAcc, updatePass, UpdatePassCmd.PROPERTIES.userAccount);
		GUIComponentBinding.create(pass1.value, updatePass, UpdatePassCmd.PROPERTIES.password);
		GUIComponentBinding.create(pass2.value, updatePass, UpdatePassCmd.PROPERTIES.verification);
		updatePass.styleName.set(Text.fromString("submitButton"));
		updatePass.confirmationRequired.set(Boolean.TRUE);
		updatePass.confirmationMessage.set(Text.fromString("${Are you sure you wish to update password?}"));
		GUIButtonComponent close = GUIButtonComponent.create(rootPanel, "${Close}");
		GUIComponentBinding.create(close.click, hide);
		close.styleName.set(Text.fromString("submitButton"));
	}
}