	public void initBestsellersFragment() {
		GUILabelComponent.create(rootPanel, "${Bestsellers}").styleName.set(Text.fromString("heading");
		bestsellersGallery = new GalleryFragment(rootPanel);
		GUICommandComponent getBestsellersCmd = new GUICommandComponent(rootPanel, new BestsellersCmd(), PerformImmediately.EXECUTE);
		GUIComponentBinding.create(getBestsellersCmd, BestsellersCmd.PROPERTIES.collection, bestsellersGallery.element);
		GUIComponentBinding.create(getBestsellersCmd.commmandExecuted, bestsellersGallery.refreshContents);
	}
	protected GUIContainerComponent getDynamicContents(IElement el) {
		GUIPanelComponent gpc = GUIPanelComponent.createTable(null);
		List<Product> products = (List<Product>) el.read();
		int row = 0, column = 0;
		for (Product p : products) {
			GUIPanelComponent picDiv = GUIPanelComponent.createFlow(gpc);
			TableLayoutData.setRowColumn(picDiv, row, column++);
			GUIHTMLComponent.create(picDiv, generatePictureHTMLFrame(p.mainImage.val()));
			GUISingleElementComponent productLink = GUISingleElementComponent.create(picDiv);
			GUIBufferComponent buf = GUIBufferComponent.create(gpc, true, p);
			GUIComponentBinding.create(buf.output, productLink.element);
			if (column > 4) {
				column = 0;
				row++;
			}
		}
		return gpc;
	}
	private String generatePictureHTMLFrame(Picture p) {
		StringBuilder sb = new StringBuilder();
		String urlPic = FileService.makeURL(p.picture.val());
		String urlThumb = FileService.makeURL(p.thumbnail.val());
		String title = p.title.val().toString();
		if (!title.isEmpty())
			title = "title=\"" + title + "\"";
		sb.append("<a href=\"").append(urlPic).append("\"  ").append(title).append(">");
		sb.append("<img src=\"").append(urlThumb).append("\" ").append(" alt=\"\"/>");
		sb.append("</a>");
		return sb.toString();
	}