﻿	protected GUIContainerComponent getDynamicContents(IElement el) {
		GUIPanelComponent gpc = GUIPanelComponent.createTable(null);
		GUIPanelComponent temp = GUIPanelComponent.createFlow(gpc);
		Cart c = (Cart) el;
		boolean sale = c.getSalesInfo();
		GUIBufferComponent cartBuffer = GUIBufferComponent.create(temp, true, c);
		GUICommandComponent updateCmd = GUICommandComponent.create(temp, DynamicPanelCommands.updateCartCmd(taxView), PerformImmediately.NOTHING);
		GUIComponentBinding.create(cartBuffer, updateCmd, UpdateCartCmd.PROPERTIES.cart);
		int row = 1;
		for (CartItem ci : c.items.read()) {
			int column = 0;
			GUIBufferComponent ciBuffer = GUIBufferComponent.create(temp, true, ci);
			GUIButtonComponent remBtn = GUIButtonComponent.create(gpc, "${Remove}", new RemoveItemCmd(), row, column++);
			GUIComponentBinding.create(ciBuffer.output, remBtn, RemoveItemCmd.PROPERTIES.cartItem);
			GUIElementComponent quanta = GUIElementComponent.createSlotEditor(gpc, CartItem.PROPERTIES.quantity, ciBuffer.output, row, column++);
			GUISingleElementComponent item = GUISingleElementComponent.create(gpc, row, column++);
			GUIComponentBinding.create(ciBuffer.output, item.element);
			GUIElementComponent price = GUIElementComponent.createSlotEditor(gpc, Product.PROPERTIES.price, new GUIFieldWidget(), GUISlotValueInput.create(CartItem.PROPERTIES.product), row, column++);
			GUIComponentBinding.create(ciBuffer.output, GUISlotValueInput.get(price).element);
			GUISlotEditorKind.get(price).readOnly.set(Boolean.TRUE);
			GUISlotEditorKind.get(price).displayAsLabel.set(Boolean.TRUE);
			if (sale) {
				GUIElementComponent salesPrice = GUIElementComponent.createSlotEditor(gpc, Product.PROPERTIES.salesPrice, new GUIFieldWidget(), GUISlotValueInput.create(CartItem.PROPERTIES.product), row, column++);
				GUIComponentBinding.create(ciBuffer.output, GUISlotValueInput.get(salesPrice).element);
				GUISlotEditorKind.get(salesPrice).readOnly.set(Boolean.TRUE);
				GUISlotEditorKind.get(salesPrice).displayAsLabel.set(Boolean.TRUE);
			}
			GUILabelComponent itemTotal = GUILabelComponent.create(gpc, "", row, column++);
			GUIComponentBinding.create(updateCmd, UpdateCartCmd.PROPERTIES.totalItem, itemTotal.label);
			GUIComponentBinding.create(GUIFieldWidget.get(quanta).focusLost, updateCmd.click);
			row++;
		}
		if (row == 1) {
			GUILabelComponent.create(temp, "${Your cart is empty.}");
		} else {
			int col = 1;
			GUILabelComponent.create(gpc, "${Quantity}", 0, col++);
			GUILabelComponent.create(gpc, "${Item}", 0, col++);
			GUILabelComponent.create(gpc, "${Price}", 0, col++);
			if (sale) {
				GUILabelComponent.create(gpc, "${Sales Price}", 0, col++);
			}
			String heading = taxView ? "${Total (inc. tax)}" : "${Total}";
			GUILabelComponent.create(gpc, heading, 0, col++);
			GUILabelComponent cartTotal = GUILabelComponent.create(gpc, "", row, 4);
			GUIComponentBinding.create(updateCmd, UpdateCartCmd.PROPERTIES.total, cartTotal.label);
		}
		return gpc;
	}
	public void initCartFragment() {
		GUILabelComponent.create(rootPanel, "$Your Cart");
		CartDynamicPanel cdp = new CartDynamicPanel(cart, taxView);
		rootPanel.children.add(cdp);
		GUIButtonComponent checkoutLink = GUIButtonComponent.create(rootPanel, "${Checkout}");
		checkoutLink.displayAsLink.set(Boolean.TRUE);
		GUIComponentBinding.create(checkoutLink.click, nextPanel.show);
	}