	public void satchmoContactFragment() {
		GUILabelComponent.create(mainPanel, "${Checkout}").styleName.set(Text.fromString("bold"));
		
		GUIPanelComponent progressLine = GUIPanelComponent.createFlow(mainPanel);
		GUILabelComponent.create(progressLine, "${Ship/Bill}").styleName.set(Text.fromString("progressFloat"));
		GUILabelComponent.create(progressLine, "${Payment}").styleName.set(Text.fromString("progressFloat"));
		GUILabelComponent.create(progressLine, "${Confrimation}").styleName.set(Text.fromString("progressFloat"));

		GUILabelComponent.create(mainPanel, "${Please complete the following information in order to submit your order.}").styleName.set(Text.fromString("bold"));
		GUILabelComponent.create(mainPanel, "${If you already have an account, you can login now to fill in most of the information below. This is just a convenience, no account is required! }").styleName.set(Text.fromString("notice"));
		
		GUIPanelComponent loginTable = GUIPanelComponent.createTable(mainPanel);
		GUILabelComponent.create(loginTable, "${Name:}", 0, 0);
		GUILabelComponent.create(loginTable, "${Password:}", 1, 0);
		GUIElementComponent username = GUIElementComponent.createInput(loginTable, "", Text.CLASSIFIER, 0, 1);
		GUIElementComponent password = GUIElementComponent.createInput(loginTable, "", Text.CLASSIFIER, 0, 1);
		GUIFieldWidget.get(password).isPassword.set(Boolean.TRUE);
		
		GUIButtonComponent loginBtn = GUIButtonComponent.create(loginTable, "${Login}", new LoginCommand());
		GUIComponentBinding.create(username.value, loginBtn, LoginCommand.PROPERTIES.username);
		GUIComponentBinding.create(password.value, loginBtn, LoginCommand.PROPERTIES.password);
		
		GUILabelComponent.create(mainPanel, "${You'll need to fill out at least the fields with a *}").styleName.set(Text.fromString("notice"));
		
		GUILabelComponent.create(mainPanel, "${Basic information}").styleName.set(Text.fromString("bold"));

		int row = 0;
		
		GUIPanelComponent basicTable = GUIPanelComponent.createTable(mainPanel);
		GUILabelComponent.create(basicTable, "${Email address*}", row++, 0);
		GUILabelComponent.create(basicTable, "${First name*}", row++, 0);
		GUILabelComponent.create(basicTable, "${Last name*}", row++, 0);
		GUILabelComponent.create(basicTable, "${Phone number*}", row++, 0);
		
		row = 0;
		GUIElementComponent email = GUIElementComponent.createInput(basicTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent firstName = GUIElementComponent.createInput(basicTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent lastName = GUIElementComponent.createInput(basicTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent phone= GUIElementComponent.createInput(basicTable, "", Text.CLASSIFIER, row++, 1);
		
		GUILabelComponent.create(mainPanel, "${Billing information}").styleName.set(Text.fromString("bold"));
		
		AddressFragment billing = new AddressFragment(mainPanel, false);
		
		GUILabelComponent.create(mainPanel, "${Shipping information}").styleName.set(Text.fromString("bold"));
		
		GUIElementComponent checkbox = GUIElementComponent.createInput(mainPanel, "", Boolean.CLASSIFIER);
		GUIFieldWidget.get(checkbox).checkboxLabel.set(Text.fromString("${Same as billing?}"));
		
		AddressFragment shipping = new AddressFragment(mainPanel, true);
		
		GUIComponentBinding.create(checkbox.value, shipping.disable);
		
		GUICommandComponent concatCmd = GUICommandComponent.create(mainPanel, new ConcatCommand(), PerformImmediately.NOTHING);
		GUIComponentBinding.create(firstName.value, concatCmd, ConcatCommand.PROPERTIES.first);
		GUIComponentBinding.create(lastName.value, concatCmd, ConcatCommand.PROPERTIES.last);
		GUIComponentBinding.create(concatCmd, ConcatCommand.PROPERTIES.concat, billing.concatName);
		GUIComponentBinding.create(concatCmd, ConcatCommand.PROPERTIES.concat, shipping.concatName);
		GUIComponentBinding.create(GUIFieldWidget.get(firstName).focusLost, concatCmd.click);
		GUIComponentBinding.create(GUIFieldWidget.get(lastName).focusLost, concatCmd.click);
		
		GUILabelComponent.create(mainPanel, "${Discounts}").styleName.set(Text.fromString("bold"));
		GUILabelComponent.create(mainPanel, "${Discount Code}");
		GUIElementComponent discount = GUIElementComponent.createInput(mainPanel, "", Text.CLASSIFIER);
		
		GUIButtonComponent next = GUIButtonComponent.create(mainPanel, "${Continue checkout}", new Contact2CheckoutCmd());
		
	}
	
	public void addressFragmentInit(boolean isShipping, ISlot<Text> disable, ISlot<Text> concatName) {
		int row = 0;
		GUIPanelComponent billingTable = GUIPanelComponent.createTable(mainPanel);
		GUIPanelComponent multiLabel = GUIPanelComponent.createFlow(billingTable);
		TableLayoutData.setRowColumn(multiLabel, row++, 0);
		String label = isShipping ? "${Street}" : "${Street*}";
		GUILabelComponent.create(multiLabel, "${Bill To}");
		GUILabelComponent.create(multiLabel, "${If different from the first and last names above}").styleName.set(Text.fromString("small_notice"));
		GUILabelComponent.create(billingTable, label, row++, 0);
		GUILabelComponent.create(billingTable, "${Street}", row++, 0);
		label = isShipping ? "${City}" : "${City*}";
		GUILabelComponent.create(billingTable, label, row++, 0);
		GUILabelComponent.create(billingTable, "${State}", row++, 0);
		label = isShipping ? "${Zipcode/Postcode}" : "${Zipcode/Postcode*}";
		GUILabelComponent.create(billingTable, label, row++, 0);
		
		row = 0;
		GUIElementComponent name = GUIElementComponent.createInput(billingTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent street1 = GUIElementComponent.createInput(billingTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent street2 = GUIElementComponent.createInput(billingTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent city = GUIElementComponent.createInput(billingTable, "", Text.CLASSIFIER, row++, 1);
		GUIElementComponent state = GUIElementComponent.createInput(billingTable, new GUIComboWidget(), new GUICollectionInput(), row++, 1);
		GUIElementComponent zip = GUIElementComponent.createInput(billingTable, "", Text.CLASSIFIER, row++, 1);
		
		GUIFindAllInstancesSAPComponent sap = GUIFindAllInstancesSAPComponent.create(mainPanel, State.FQ_TYPE_NAME);
		GUIComponentBinding.create(sap.value, GUICollectionInput.get(state).collection);
		
		GUINotGate gng = GUINotGate.create(mainPanel);
		GUIComponentBinding.create(disable, gng.input);
		
		GUIComponentBinding.create(concatName, name.value);
		GUIComponentBinding.create(gng.output, street1.enabled);
		GUIComponentBinding.create(gng.output, street2.enabled);
		GUIComponentBinding.create(gng.output, city.enabled);
		GUIComponentBinding.create(gng.output, state.enabled);
		GUIComponentBinding.create(gng.output, zip.enabled);
	}
	
	public void executeConcatCommand(ISlot<Text> first, ISlot<Text> last) {
		Text f = first.val();
		Text l = last.val();
		String concat = (f != null ? f.toString() : "") + " " + (l != null ? l.toString() : "");
		concatName.set(Text.fromString(concat));
	}
	
	public void doCheckPreconditionsCheckoutCommand() {
		boolean throwUp = false;
		String message = "";
		if (email.val() == null) {
			throwUp = true;
			message += "You must enter First Name.\n";
		}
		if (firstName.val() == null) {
			throwUp = true;
			message += "You must enter First Name.\n";
		}
		if (lastName.val() == null) {
			throwUp = true;
			message += "You must enter First Name.\n";
		}
		if (phone.val() == null) {
			throwUp = true;
			message += "You must enter First Name.\n";
		}
		if (street1.val() == null) {
			throwUp = true;
			message += "You must enter First Name.\n";
		}
		if (city.val() == null) {
			throwUp = true;
			message += "You must enter First Name.\n";
		}
		
		if (throwUp)
			throw new CommandPreconditionsException(message);
	}